## class SG_EXPORT osg::TexGen

> TexGen - encapsulates the OpenGL glTexGen (texture coordinate generation) state

## Inheritance:

### Public Methods

TexGen()
TexGen(const TexGen& texgen, const CopyOp& copyop=CopyOp::SHALLOW_COPY)
  Copy constructor using CopyOp to manage deep vs shallow copy
META_StateAttribute(osg, TexGen, TEXGEN)
virtual bool isTextureAttribute() const
virtual int compare(const StateAttribute& sa) const
  return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs
virtual void getAssociatedModes(std::vector<GLMode>& modes) const
virtual void apply(State& state) const
inline void setMode( Mode mode )
Mode getMode() const
void setPlane(Coord which, const Plane& plane)
Plane& getPlane(Coord which)
const Plane& getPlane(Coord which) const

### Public Members

enum Mode
enum Coord

### Protected Fields

Mode _mode
Plane _plane_s
  additional texgen coefficents for GL_OBJECT_PLANE or GL_EYE_PLANE,
Plane _plane_t
Plane _plane_r
Plane _plane_q

### Protected Methods

virtual ~TexGen( void )

### Inherited from StateAttribute:

### Public Methods

virtual Object* cloneType() const
virtual Object* clone(const CopyOp&) const
virtual bool isSameKindAs(const Object* obj) const
virtual const char* libraryName() const
virtual const char* className() const
virtual Type getType() const
bool operator < (const StateAttribute& rhs) const
bool operator == (const StateAttribute& rhs) const
bool operator != (const StateAttribute& rhs) const
virtual void compile(State&) const

### Public Members

typedef GLenum GLMode
typedef unsigned int GLModeValue
typedef unsigned int OverrideValue
enum Values
typedef unsigned int Type
enum Types

### Inherited from Object:

### Public Methods

inline void setDataVariance(DataVariance dv)
inline DataVariance getDataVariance() const
inline void setUserData(Referenced* obj)
inline Referenced* getUserData()
inline const Referenced* getUserData() const

### Public Members

enum DataVariance

### Protected Fields

DataVariance _dataVariance
ref_ptr<Referenced> _userData

### Inherited from Referenced:

### Public Methods

inline Referenced& operator = (Referenced&)
static void setDeleteHandler(DeleteHandler* handler)
static DeleteHandler* getDeleteHandler()
inline void ref() const
inline void unref_nodelete() const
inline int referenceCount() const
inline void unref() const

### Protected Fields

mutable int _refCount

## Documentation

> TexGen - encapsulates the OpenGL glTexGen (texture coordinate generation) state

`TexGen()`

`TexGen(const TexGen& texgen, const CopyOp& copyop=CopyOp::SHALLOW_COPY)`
  Copy constructor using CopyOp to manage deep vs shallow copy

`META_StateAttribute(osg, TexGen, TEXGEN)`

`virtual bool isTextureAttribute() const`

`virtual int compare(const StateAttribute& sa) const`
  return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs

`virtual void getAssociatedModes(std::vector<GLMode>& modes) const`

`virtual void apply(State& state) const`

`enum Mode`

`OBJECT_LINEAR`

`EYE_LINEAR`

`SPHERE_MAP`

`NORMAL_MAP`

`REFLECTION_MAP`

`inline void setMode( Mode mode )`

`Mode getMode() const`

`enum Coord`

`S`

`T`

`R`

`Q`

`void setPlane(Coord which, const Plane& plane)`

`Plane& getPlane(Coord which)`

`const Plane& getPlane(Coord which) const`

`virtual ~TexGen( void )`

`Mode _mode`

`Plane _plane_s`
  additional texgen coefficents for GL_OBJECT_PLANE or GL_EYE_PLANE,

`Plane _plane_t`

`Plane _plane_r`

`Plane _plane_q`

This class has no child classes.

Alphabetic index HTML hierarchy of classes or Java

This page was generated with the help of DOC++.